echo "Hash Benchmark - read 50% - Multiprogramming"
echo
:>"experiments/results/hash-multiprogramming/hash-r50.csv"
for i in 1 2 4 8 16 24 32 48 60 96 128 160 196 256
do

	ringsw_throughput=0
	norec_throughput=0
	tl2_throughput=0
	rtc_throughput=0
	concurrent_throughput=0
	nonblocking_throughput=0
	
for (( j = 1 ; j <= 5; j++ ))
do

	export STM_CONFIG=RingSW
	ringsw_throughput=`expr $ringsw_throughput + $(echo "$(./../rstm_build/bench/HashBenchSSB64 -p $i -m 65536 -R 50 -N 100)" | egrep -e 'throughput=[^ ]*' -o | cut -d = -f 2)`

	export STM_CONFIG=NOrec
	norec_throughput=`expr $norec_throughput + $(echo "$(./../rstm_build/bench/HashBenchSSB64 -p $i -m 65536 -R 50 -N 100)" | egrep -e 'throughput=[^ ]*' -o | cut -d = -f 2)`

	export STM_CONFIG=OrecELA
	tl2_throughput=`expr $tl2_throughput + $(echo "$(./../rstm_build/bench/HashBenchSSB64 -p $i -m 65536 -R 50 -N 100)" | egrep -e 'throughput=[^ ]*' -o | cut -d = -f 2)`

	export STM_CONFIG=RTCDD
	rtc_throughput=`expr $rtc_throughput + $(echo "$(./../rstm_build/bench/HashBenchSSB64 -p $i -m 65536 -R 50 -N 100)" | egrep -e 'throughput=[^ ]*' -o | cut -d = -f 2)`

	concurrent_throughput=`expr $concurrent_throughput + $(echo "$(./../libcuckoo-master/tests/read_throughput.out --thread-num $i --time 1 --power 16 --load 50)" | egrep -e 'Throughput: [^ ]*' -o | cut -d ' ' -f 2)`

	temp=$(echo "$(./../nbds.0.4.3/output/perf_test $i 10)" | egrep -e 'Mops/s:[^ ]*' -o | cut -d : -f 2)
	nonblocking_throughput=$(echo $nonblocking_throughput $temp | awk ' { printf "%f\n", $1 + $2 } ') 
		
done

	ringsw_throughput=`expr $ringsw_throughput / 5`
	rtc_throughput=`expr $rtc_throughput / 5`
	norec_throughput=`expr $norec_throughput / 5`
	tl2_throughput=`expr $tl2_throughput / 5`
	concurrent_throughput=`expr $concurrent_throughput / 5`
	nonblocking_throughput=$(echo $nonblocking_throughput 5.0 | awk ' { printf "%f\n", $1 / $2 } ')

	echo "Number of threads: " $i
	echo "RingSTM: " $ringsw_throughput
	echo "NOrec: " $norec_throughput
	echo "TL2: " $tl2_throughput
	echo "RTC: " $rtc_throughput
	echo "Concurrent: " $concurrent_throughput	
	echo "Nonblocking: " $nonblocking_throughput	
	echo

	echo $i $ringsw_throughput $norec_throughput $tl2_throughput $rtc_throughput $concurrent_throughput $nonblocking_throughput>> "experiments/results/hash/hash-multiprogramming-r50.csv"
	
done
