# This experiment should be repeated for different number of cores.
# use sudo vi /sys/devices/system/cpu/cpu$$/online to enable/disable core by putting 1/0.
#Then rename the output files to match with the names in the .gp file.
echo "Tree Benchmark - read 50%"
echo
:>"experiments/results/tree-multiprogramming/tree-r50.csv"
for i in 1 2 4 8 16 24 32 48 64 96 128 160 196 256
#for i in 1 2 4 8 12 16 20 24 28 32 36 40 44
do

	ringsw_throughput=0
	norec_throughput=0
	tl2_throughput=0
	rtc_throughput=0
	
for (( j = 1 ; j <= 5; j++ ))
do

	export STM_CONFIG=RingSW
	ringsw_throughput=`expr $ringsw_throughput + $(echo "$(./../rstm_build/bench/TreeBenchSSB64 -p $i -m 66560 -R 50 -N 100)" | egrep -e 'throughput=[^ ]*' -o | cut -d = -f 2)`

	export STM_CONFIG=NOrec
	norec_throughput=`expr $norec_throughput + $(echo "$(./../rstm_build/bench/TreeBenchSSB64 -p $i -m 66560 -R 50 -N 100)" | egrep -e 'throughput=[^ ]*' -o | cut -d = -f 2)`

	export STM_CONFIG=OrecELA
	tl2_throughput=`expr $tl2_throughput + $(echo "$(./../rstm_build/bench/TreeBenchSSB64 -p $i -m 66560 -R 50 -N 100)" | egrep -e 'throughput=[^ ]*' -o | cut -d = -f 2)`

	export STM_CONFIG=RTCDD
	rtc_throughput=`expr $rtc_throughput + $(echo "$(./../rstm_build/bench/TreeBenchSSB64 -p $i -m 66560 -R 50 -N 100)" | egrep -e 'throughput=[^ ]*' -o | cut -d = -f 2)`

done

	ringsw_throughput=`expr $ringsw_throughput / 5`
	norec_throughput=`expr $norec_throughput / 5`
	tl2_throughput=`expr $tl2_throughput / 5`
	rtc_throughput=`expr $rtc_throughput / 5`

	echo "Number of threads: " $i
	echo "RingSTM: " $ringsw_throughput
	echo "NOrec: " $norec_throughput
	echo "TL2: " $tl2_throughput
	echo "RTC: " $rtc_throughput	
	echo

	echo $i $ringsw_throughput $norec_throughput $tl2_throughput $rtc_throughput >> "experiments/results/tree-multiprogramming/tree-r50.csv"
	
done

