#set term postscript eps enhanced color 22
#set autoscale
#set xlabel "Threads" font "Times-Roman, 50"
#set xtics font "Times-Roman, 30" 
#set ylabel "Throughput" font "Times-Roman, 50"
#set ytics font "Times-Roman, 30" 

for b in genome vacation kmeans ssca2 labyrinth intruder; do

g=../rstm/experiments/plots/${b}.gp
eps=../rstm/experiments/plots/${b}.eps
	
echo "set terminal postscript eps enhanced mono dashed lw 1 \"Helvetica\" 30" > ${g}
echo "set pointsize 2"  >> ${g}                              # larger point!

echo "set key off" >> ${g}
#echo "set key top" >> ${g}
#echo "set key right" >> ${g}
#echo "set xtics 1" >> ${g}
echo "set xlabel \"Number of threads\"" >> ${g}
echo "set ylabel \"Time in Seconds\"" >> ${g}
echo "set output \"${eps}\"" >> ${g}
echo -n "plot " >> ${g}


#for alg in RingSW NOrec OrecELA RTCDD RTCFC; do
for alg in RingSW NOrec OrecELA LLT Swiss RTCDD RTCFC; do

    algname=$alg
    if [ "${alg}" == "OrecELA" ]; then
	algname=TL2
    fi
    if [ "${alg}" == "LLT" ]; then
	algname=Unsafe-TL2
    fi
    if [ "${alg}" == "Swiss" ]; then
	algname=Unsafe-Swiss
    fi
   if [ "${alg}" == "RTCDD" ]; then
	algname=RTC
    fi
   if [ "${alg}" == "RTCFC" ]; then
	algname=RTC-FC
    fi

    data=../rstm/experiments/results/stamp/${b}-${alg}.csv
    echo -n "\"${data}\" using 1:(\$2) title \"${algname}\" with linespoints" >> ${g}
    if [ "${alg}" != "RTCFC" ]; then
        echo ", \\" >> ${g}
        echo -n "    " >> ${g}
    else
        echo "" >> ${g}	
    fi
done

gnuplot ${g}
epstopdf ${eps}

done
